#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
# -----------------------------------------------------------------------------------------------
#    Name:	Tile Component Array
#      By:	sdmitch
#   Usage:	Place selected component on a rectangular grid.
#	 	 Note:	Faces do not have to be on the XY plane.  Option to group array and erase face.
#						Any tile touching the selected face will be placed.  Enter the size of the tile plus
#						the width of desired gap between the tiles.
#    Date:	Mar 2013
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
module SDM

	module Tile_Component_Array

		def self.main
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			defs=mod.definitions
			@gridX = '300'.to_l unless @gridX
			@gridY = '300'.to_l unless @gridY
			@angle = 0 unless @angle
			@Make_Group = "Ja" unless @Make_Group
			#@Group_Face = "Ja" unless @Group_Face
			@face=sel.grep(Sketchup::Face)[0]
			if @face
				@names=[];defs.each{|d| @names<<d.name if !d.group? && !d.image?}
				prompts=["Komponente:","Fliesen X+Fuge:","Fliesen Y+Fuge:","Fliesendrehung:","Anordnung Gruppieren:"]
				defaults=[@names[0],@gridX,@gridY,@angle,@Make_Group]
				options=[@names.join("|"),nil,nil,nil,"Ja|Nein","Ja|Nein"]
				inp_data=inputbox(prompts,defaults,options,"Komponentenanordnung")
				unless inp_data then;return;end
				@C_Name=inp_data[0];@Comp=defs[@C_Name];@gridX=inp_data[1].to_l;@gridY=inp_data[2].to_l
				@angle=inp_data[3].to_i; @Make_Group=inp_data[4]; 
				  @Count = 0
				mod.start_operation "Komponentenanordnung"
				@Make_Group=="Ja" ? (grp = ent.add_group;@arr = grp.entities) : @arr = ent
				pl=@face.plane;ctr=@face.bounds.center; norm=@face.normal; #norm.reverse! if norm.z < 0; 
				ctr=ctr.project_to_plane pl unless ctr.on_plane? pl; @xaxis,@yaxis,@zaxis=norm.axes
				tr = Geom::Transformation.rotation(ctr,norm,@angle.degrees);
				@xaxis.transform! tr; @yaxis.transform! tr; maxd = @face.bounds.diagonal*2
				@pt0=ctr.offset(@xaxis.reverse,maxd/2).offset(@yaxis.reverse,maxd/2)
				nx=(maxd/@gridX).ceil;ny=(maxd/@gridY).ceil; #puts "nx=#{nx}, ny=#{ny}"
				self.rectangular_array(nx,ny)
				grp.name="#{@Count} X #{@C_Name}" if @Make_Group=="Ja"
				(@arr.add_face(@face.outer_loop.vertices);@face.edges.each{|e| e.erase!}) if @Group_Face=="Ja"
				mod.commit_operation
			else
				UI.messagebox "Whlen Sie die Flche aus"
			end
		end
		
		def self.rectangular_array(nx,ny)
			for i in 0..ny
				pt1=@pt0.clone; 
				for j in 0..nx
					# Sketchup.active_model.active_entities.add_cpoint(pt1)
					tr=Geom::Transformation.new pt1,@zaxis
					tile=@arr.add_instance(@Comp,tr)
					tr=Geom::Transformation.new pt1,@zaxis,@angle.degrees
					tile.transform! tr; keep=false
					for k in 0..7
						next unless [1,2,4].include?(@face.classify_point(tile.bounds.corner(k).project_to_plane(@face.plane)))
						@Count += 1; keep=true; break
					end
					tile.erase! unless keep
					pt1.offset!(@xaxis,@gridX);
				end 
				@pt0.offset!(@yaxis,@gridY)
			end
		end
	end
end
# ------------------  MENU SETUP ---------------------- #
#unless $sdm_tools_menu
#	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
#	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
#	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
#	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
#	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
#end
#unless file_loaded?(__FILE__)
#	$sdm_CorG_tools.add_item("Tile Component Array") { SDM::Tile_Component_Array.main }
#	file_loaded(__FILE__)
#end
# ------------------------------------------------------ #
@cmd = UI::Command.new("ComponentArray") {  SDM::Tile_Component_Array.main } 
  @cmd.small_icon = "../images/arr.png" 
  @cmd.large_icon = "../images/arr.png"
  @cmd.tooltip = "Fliesenanordnung"